diff options
author | Junio C Hamano <gitster@pobox.com> | 2010-01-30 16:03:10 -0800 |
---|---|---|
committer | Junio C Hamano <gitster@pobox.com> | 2010-01-30 16:03:10 -0800 |
commit | 00d3278c8534a8244ae3447189401111e017fd5d (patch) | |
tree | f1c19903bc10ffe4816642040080fb6cfd5da376 /git-request-pull.sh | |
parent | b9b727ddb3c9e005bc4e9af0b990b6ef06d7f621 (diff) | |
parent | b319ef70a94731a5c6f18d07a49d5dda3f06f5d3 (diff) | |
download | git-00d3278c8534a8244ae3447189401111e017fd5d.tar.gz git-00d3278c8534a8244ae3447189401111e017fd5d.tar.xz |
Merge commit 'b319ef7' into jc/maint-fix-test-perm
* commit 'b319ef7': (8132 commits)
Add a small patch-mode testing library
git-apply--interactive: Refactor patch mode code
t8005: Nobody writes Russian in shift_jis
Fix severe breakage in "git-apply --whitespace=fix"
Update release notes for 1.6.4
After renaming a section, print any trailing variable definitions
Make section_name_match start on '[', and return the length on success
send-email: detect cycles in alias expansion
Show the presence of untracked files in the bash prompt.
SunOS grep does not understand -C<n> nor -e
Fix export_marks() error handling.
git repack: keep commits hidden by a graft
Add a test showing that 'git repack' throws away grafted-away parents
git branch: clean up detached branch handling
git branch: avoid unnecessary object lookups
git branch: fix performance problem
git svn: fix shallow clone when upstream revision is too new
do_one_ref(): null_sha1 check is not about broken ref
configure.ac: properly unset NEEDS_SSL_WITH_CRYPTO when sha1 func is missing
janitor: useless checks before free
...
Diffstat (limited to 'git-request-pull.sh')
-rwxr-xr-x | git-request-pull.sh | 51 |
1 files changed, 38 insertions, 13 deletions
diff --git a/git-request-pull.sh b/git-request-pull.sh index 4eacc3a05..591777324 100755 --- a/git-request-pull.sh +++ b/git-request-pull.sh @@ -4,30 +4,55 @@ # This file is licensed under the GPL v2, or a later version # at the discretion of Linus Torvalds. -USAGE='<commit> <url> [<head>]' -LONG_USAGE='Summarizes the changes since <commit> to the standard output, -and includes <url> in the message generated.' +USAGE='<start> <url> [<end>]' +LONG_USAGE='Summarizes the changes between two commits to the standard output, +and includes the given URL in the generated summary.' SUBDIRECTORY_OK='Yes' +OPTIONS_SPEC= . git-sh-setup +. git-parse-remote -revision=$1 +GIT_PAGER= +export GIT_PAGER + +base=$1 url=$2 head=${3-HEAD} -[ "$revision" ] || usage +[ "$base" ] || usage [ "$url" ] || usage -baserev=`git-rev-parse --verify "$revision"^0` && -headrev=`git-rev-parse --verify "$head"^0` || exit +baserev=`git rev-parse --verify "$base"^0` && +headrev=`git rev-parse --verify "$head"^0` || exit + +merge_base=`git merge-base $baserev $headrev` || +die "fatal: No commits in common between $base and $head" + +url=$(get_remote_url "$url") +branch=$(git ls-remote "$url" \ + | sed -n -e "/^$headrev refs.heads./{ + s/^.* refs.heads.// + p + q + }") +if [ -z "$branch" ]; then + echo "warn: No branch of $url is at:" >&2 + git log --max-count=1 --pretty='tformat:warn: %h: %s' $headrev >&2 + echo "warn: Are you sure you pushed $head there?" >&2 + echo >&2 + echo >&2 + branch=..BRANCH.NOT.VERIFIED.. + status=1 +fi echo "The following changes since commit $baserev:" -git log --max-count=1 --pretty=short "$baserev" | -git-shortlog | sed -e 's/^\(.\)/ \1/' +git shortlog --max-count=1 $baserev | sed -e 's/^\(.\)/ \1/' -echo "are found in the git repository at:" +echo "are available in the git repository at:" echo -echo " $url" +echo " $url $branch" echo -git log $baserev..$headrev | git-shortlog ; -git diff -M --stat --summary $baserev..$headrev +git shortlog ^$baserev $headrev +git diff -M --stat --summary $merge_base $headrev +exit $status |